﻿using CWSWrapper;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace CWSTransApp
{
    /// <summary>
    /// Interaction logic for HealthcareAmountsDialog.xaml
    /// </summary>
    public partial class HealthcareAmountsDialog : Window
    {
        private CurrencyCode m_currencyCode;

        public Money otcAmount;
        public Money prescriptionAmount;
        public Money clinicAmount;
        public Money dentalAmount;
        public Money visionAmount;
        public Money transitAmount;

        public bool CancelTransaction = false;

        public HealthcareAmountsDialog(string currencyCode)
        {
            InitializeComponent();
            m_currencyCode = Money.CurrencyCodefromString(currencyCode);
        }

        private void Ok_Button_Click(object sender, RoutedEventArgs e)
        {
            String otcAmountStr = tb_otc_amount.Text;
            if (otcAmountStr.Length > 0)
            {
                otcAmount = new Money(m_currencyCode, otcAmountStr);
            }
            String prescriptionAmountStr = tb_prescription_amount.Text;
            if (prescriptionAmountStr.Length > 0)
            {
                prescriptionAmount = new Money(m_currencyCode, prescriptionAmountStr);
            }
            String clinicAmountStr = tb_clinic_amount.Text;
            if (clinicAmountStr.Length > 0)
            {
                clinicAmount = new Money(m_currencyCode, clinicAmountStr);
            }
            String dentalAmountStr = tb_dental_amount.Text;
            if (dentalAmountStr.Length > 0)
            {
                dentalAmount = new Money(m_currencyCode, dentalAmountStr);
            }
            String visionAmountStr = tb_vision_amount.Text;
            if (visionAmountStr.Length > 0)
            {
                visionAmount = new Money(m_currencyCode, visionAmountStr);
            }
            String transitAmountStr = tb_transit_amount.Text;
            if (transitAmountStr.Length > 0)
            {
                transitAmount = new Money(m_currencyCode, transitAmountStr);
            }

            Close();
        }

        private void Cancel_Transaction_Button_Click(object sender, RoutedEventArgs e)
        {
            CancelTransaction = true;
            Close();
        }

        public bool DoHealthcareAmounts()
        {
            return otcAmount != null || prescriptionAmount != null || clinicAmount != null
                || dentalAmount != null || visionAmount != null || transitAmount != null;
        }
    }
}
