﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using CWSWrapper;

namespace CWSTransApp
{
    /// <summary>
    /// Interaction logic for QuickValues.xaml
    /// </summary>
    public partial class QuickValues : Window
    {
        private QuickSelection m_QuickSelection;
        private String currencyCode;

        public QuickValues(String currencyCodeToUse)
        {
            InitializeComponent();

            this.currencyCode = currencyCodeToUse;

            tb_Value1.Text = "9";
            tb_Value2.Text = "14";
            tb_Value3.Text = "21";

            rb_Percent1.IsChecked = true;
            rb_Percent2.IsChecked = true;
            rb_Percent3.IsChecked = true;
        }
        public QuickSelection getQuickSelection()
        {
            return m_QuickSelection;
        }
        private bool MakeQuickSelection()
        {
            bool ok = false;
            string value1 = tb_Value1.Text;
            string value2 = tb_Value2.Text;
            string value3 = tb_Value3.Text;

            if ((IsNumber(value1))
             && (IsNumber(value2))
             && (IsNumber(value3)))
            {
                bool? check;
                ok = true;

                m_QuickSelection = new QuickSelection();

                m_QuickSelection.selection1 = new Dictionary<String, String>();
                check = rb_Percent1.IsChecked;
                if ((check.HasValue) && (check.Value))
                    m_QuickSelection.selection1.Add("type", "PERCENTAGE");
                else
                    m_QuickSelection.selection1.Add("type", "MONETARY_AMOUNT");
                m_QuickSelection.selection1.Add("currencyCode", currencyCode);
                m_QuickSelection.selection1.Add("value", value1);

                m_QuickSelection.selection2 = new Dictionary<String, String>();
                check = rb_Percent2.IsChecked;
                if ((check.HasValue) && (check.Value))
                    m_QuickSelection.selection2.Add("type", "PERCENTAGE");
                else
                    m_QuickSelection.selection2.Add("type", "MONETARY_AMOUNT");
                m_QuickSelection.selection2.Add("currencyCode", currencyCode);
                m_QuickSelection.selection2.Add("value", value2);

                m_QuickSelection.selection3 = new Dictionary<String, String>();
                check = rb_Percent3.IsChecked;
                if ((check.HasValue) && (check.Value))
                    m_QuickSelection.selection3.Add("type", "PERCENTAGE");
                else
                    m_QuickSelection.selection3.Add("type", "MONETARY_AMOUNT");
                m_QuickSelection.selection3.Add("currencyCode", currencyCode);
                m_QuickSelection.selection3.Add("value", value3);
            }
            else
            {
                MessageBox.Show("All amounts must be numeric", "ERROR");
            }
            return ok;
        }
        private bool IsNumber(string somevalue)
        {
            bool ok = false;
            try
            {
                long.Parse(somevalue);
                ok = true;
            }
            catch (Exception)
            {
                ok = false;
            }
            return ok;
        }

        private void b_OK_Click(object sender, RoutedEventArgs e)
        {
            if (MakeQuickSelection())
                closeDlg();
        }

        private void b_Cancel_Click(object sender, RoutedEventArgs e)
        {
            m_QuickSelection = null;
            closeDlg();
        }
        private void closeDlg()
        {
            DialogResult = true;
            this.Close();
        }

        private void rb_Dollar1_Checked(object sender, RoutedEventArgs e)
        {
            rb_Percent1.IsChecked = false;
        }

        private void rb_Percent1_Checked(object sender, RoutedEventArgs e)
        {
            rb_Dollar1.IsChecked = false;
        }

        private void rb_Dollar2_Checked(object sender, RoutedEventArgs e)
        {
            rb_Percent2.IsChecked = false;
        }

        private void rb_Percent2_Checked(object sender, RoutedEventArgs e)
        {
            rb_Dollar2.IsChecked = false;
        }

        private void rb_Dollar3_Checked(object sender, RoutedEventArgs e)
        {
            rb_Percent3.IsChecked = false;
        }

        private void rb_Percent3_Checked(object sender, RoutedEventArgs e)
        {
            rb_Dollar3.IsChecked = false;
        }
    }
}
